
import { _decorator, Component, Node, RenderTexture, game, view, find, director, Sprite, SpriteFrame, Camera, v3, Vec3, UITransform, Size, instantiate } from 'cc';
const { ccclass, property } = _decorator;

@ccclass('Test')
export class Test extends Component {
    @property(Sprite)
    targetSprite: Sprite = null;

    @property(Camera)
    camera: Camera = null;

    //下面是三种方案的三个按钮事件监听，可以依次注释看一下

    //第一种，会闪烁
    public btnCallback1(): void{
        let texture = new RenderTexture();
        texture.reset(view.getVisibleSize());
        this.camera.targetTexture = texture;
        let newSpFrame = new SpriteFrame();
        newSpFrame.texture = texture;
        this.targetSprite.getComponent(UITransform).contentSize = view.getVisibleSize();
        this.targetSprite.spriteFrame = newSpFrame;
        this.scheduleOnce(()=>{
            this.camera.targetTexture = null;
        }, 0);
    }

    //第二种，按钮的状态还没恢复就截完了
    public btnCallback2(): void{
        // let texture = new RenderTexture();
        // texture.reset(view.getVisibleSize());
        // this.camera.targetTexture = texture;
        // let newSpFrame = new SpriteFrame();
        // newSpFrame.texture = texture;
        // this.targetSprite.getComponent(UITransform).contentSize = view.getVisibleSize();
        // this.targetSprite.spriteFrame = newSpFrame;
        // game.step();
        // this.camera.targetTexture = null;
    }

    //第三种，重复渲染两次，没有从根本上解决问题，只是肉眼上没有闪烁了，如果是多个相机的targetTexture都渲染到新的texture的话，这种方式就很不合适了
    public btnCallback3(): void{
        // let texture = new RenderTexture();
        // texture.reset(view.getVisibleSize());
        // let newCamera = instantiate(this.camera.node);
        // this.node.addChild(newCamera);
        // newCamera.getComponent(Camera).targetTexture = texture;
        // let newSpFrame = new SpriteFrame();
        // newSpFrame.texture = texture;
        // this.targetSprite.getComponent(UITransform).contentSize = view.getVisibleSize();
        // this.targetSprite.spriteFrame = newSpFrame;

        // this.scheduleOnce(()=>{
        //     newCamera.getComponent(Camera).targetTexture = null;
        //     newCamera.destroy();
        // }, 0);
    }
}
